/* $Id: changemgmt.js,v 1.3 2006/12/06 13:12:21 subbalakshmi Exp $ */
function showHide(elementId,status)
{
    var obj = findObjectsById(elementId);

    if(status == true)
    {
	obj.className = '';
    }
    else if(status == false)
    {
	obj.className = 'hide';
    }

}


function getSelectedRules(form,viewName)
{
   var tblModel = getTableModel(viewName);
   if(!tblModel.isAtleastOneChecked("Select atleast a single rule to associate"))
   {
   	return false;
   }
   
   var selIndices = tblModel.getSelectedRowIndices();
   var colInd = tblModel.getColumnIndex("RULE_ID");
   
   var pkValueStr = "";
   for(var i=0;i<selIndices.length;i++)
   {
      pkValueStr = pkValueStr + "&" + "RULE_ID" + "=" + tblModel.getValueAt(selIndices[i],colInd);
   }
   
   form.action = getURLSuffixed(form.action) + pkValueStr;
   return true;
      
}


function checkIfDGRule(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    var tblModel = getTableModel(srcViewRefId);

    var resourceId = tblModel.getValueAt(index,tblModel.getColumnIndex("RESOURCEID"));
    if(resourceId == null)
    {
	var ruleName = tblModel.getValueAt(index,tblModel.getColumnIndex("RULE_NAME"));    
        alert("This rule " + ruleName + " is associated with a device group and cannot be disassociated");
        return;
    }
    
    if(!menuItemObj.confirmAction())
    {
        return;
    }

    menuItemObj.invokeActionURL(menuItemObj.getActionURL(srcViewRefId,additionalParams,index));
    
}

function stateChange(rowId,expandedImgId,collapsedImgId)
{
   var obj = MM_findObj(rowId);
   var collapsedImage = document.getElementById(collapsedImgId);
   var expandedImage = document.getElementById(expandedImgId);	 
   
   if(obj.className == "hide")
   {
      obj.className = '';
      collapsedImage.className = 'hide';
      expandedImage.className = '';
   }
   else
   {
      obj.className = 'hide';
      collapsedImage.className = '';
      expandedImage.className = 'hide';
   }
}

function validateRuleSettings(form,ruleNames)
{
    var ruleNameEle = document.getElementById("RULE_NAME");
    // only for add rule
    if(ruleNameEle != null)
    {
    	var ruleName = ruleNameEle.value;
    	var len = ruleNames.length;
    	for(i=0;i<len;i++)
    	{
    	  if(ruleName == ruleNames[i])
    	  {
    	    alert("A rule with this name already exists. Enter a different name");
    	    return false;
    	  }
    	}
    }
    
   // checking if condition is selected
   var conditionSelected = false;
   var len = form.CONDITION.length;
   for(i=0;i<len;i++)
   {
   	if(form.CONDITION[i].checked)
   	{
           conditionSelected = true;
           break;
   	}
   }

   if(!conditionSelected)
   {
      alert("Choose a condition");
      return false;
   }
   
   // checking if atleast a single action is selected
   var sendEmail = document.getElementById("SEND_EMAIL").checked;
   var sendTrap = document.getElementById("SEND_TRAP").checked;
   var generateTicket = document.getElementById("GENERATE_TICKET").checked;
   if(!sendEmail && !sendTrap && !generateTicket)
   {
      alert("Choose one or more action(s)");
      return false;
   }
   
   // validating individual action values   
   if(sendEmail)
   {
      if(checkEmailSettings() == false)
      {
      	return false;
      }
   }
   
   if(sendTrap)
   {
      if(checkTrapSettings() == false)
      {
      	return false;
      }
   }
   
   if(generateTicket)
   {
     return checkTicketSettings();
   }

   return true;
}

function checkTrapSettings()
{
   var host = document.getElementById("HOST").value;
   host = trimAll(host);
   if(!isNotEmpty(host))
   {
     alert("Enter a value for the field 'Hostname / IP Address'");
     return false;
   }

   var value = document.getElementById("PORT").value;
   value = trimAll(value);
   if(isNotEmpty(value))
   {
    if(!isContainOnlyNumericValues(document.getElementById("PORT"),"Destination Port"))
    {
       return false;
    }
   }
   else
   {
     alert("Enter a value for the field 'Destination Port'");
     return false;
   }
   
   var comm = document.getElementById("COMMUNITY").value;
   comm = trimAll(comm);
   if(!isNotEmpty(comm))
   {
     alert("Enter a value for the field 'Community'");
     return false;
   }
   
   return true;

}

function checkEmailSettings()
{
  var toAddress = document.getElementById("TO_ADDRESS").value;
  toAddress = trimAll(toAddress);
  if(!isNotEmpty(toAddress))
  {
    alert("Enter the recipients in the 'Send Email Notification to' field");
    return false;
  }  
  
  var toAddrArray = toAddress.split(",");
  var len = toAddrArray.length;
  for(i=0;i<len;i++)
  {
     if(!checkEmailAddress(toAddrArray[i]))
     {
       return false;
     }
  }
  
  var emailSubject = document.getElementById("EMAIL_SUBJECT").value;
  emailSubject = trimAll(emailSubject);
  if(!isNotEmpty(emailSubject))
  {
    alert("Enter a value for the field 'Subject'");
    return false;
  }
  
  var emailMessage = document.getElementById("EMAIL_MESSAGE").value;
  emailMessage = trimAll(emailMessage);
  if(!isNotEmpty(emailMessage))
  {
    alert("Enter a value for the field 'Message'");
    return false;
  }
  
  return true;
   
}

function checkTicketSettings()
{
  var toAddress = document.getElementById("TICKET_TO_ADDRESS").value;
  toAddress = trimAll(toAddress);
  if(!isNotEmpty(toAddress))
  {
    alert("Enter the recipients in the 'Send Trouble Ticket to' field");
    return false;
  }  
  
  var toAddrArray = toAddress.split(",");
  var len = toAddrArray.length;
  for(i=0;i<len;i++)
  {
     if(!checkEmailAddress(toAddrArray[i]))
     {
       return false;
     }
  }
  
  var ticketSubject = document.getElementById("TICKET_SUBJECT").value;
  ticketSubject = trimAll(ticketSubject);
  if(!isNotEmpty(ticketSubject))
  {
    alert("Enter a value for the field 'Ticket Subject'");
    return false;
  }
  
  var ticketMessage = document.getElementById("TICKET_MESSAGE").value;
  ticketMessage = trimAll(ticketMessage);
  if(!isNotEmpty(ticketMessage))
  {
    alert("Enter a value for the field 'Ticket Message'");
    return false;
  }
  
  return true;
   
}
