/* $Id: search.js,v 1.13 2006/11/16 06:39:12 lakshmanan Exp $ */
function doHighlight(bodyText, searchTerm, highlightStartTag, highlightEndTag)
{
  if ((!highlightStartTag) || (!highlightEndTag)) {
    highlightStartTag = "<font style='color:#000000; background-color:#A4D7F0;'>";
    highlightEndTag = "</font>";
  }

  var newText = "";
  var i = -1;
  var lcSearchTerm = searchTerm.toLowerCase();
  var lcBodyText = bodyText.toLowerCase();

  while (bodyText.length > 0) {
    i = lcBodyText.indexOf(lcSearchTerm, i+1);
    if (i < 0) {
      newText += bodyText;
      bodyText = "";
    } else {
      if (bodyText.lastIndexOf(">", i) >= bodyText.lastIndexOf("<", i)) 
      {
        // The below commented check is raising an issue in Mozilla. 
        // The lastIndexOf returns values like -3, -4 when it should return -1
        // This check is required only when the bodyText contains script tags and
        // the content inside those tags should not be highlighted.
        // Anyway this check is not required here since the bodyText will never contain 
        // script tags

        //if (lcBodyText.lastIndexOf("/script>", i) >= lcBodyText.lastIndexOf("<script", i)) 
        //{
          newText += bodyText.substring(0, i) + highlightStartTag + bodyText.substr(i, searchTerm.length) + highlightEndTag;
          bodyText = bodyText.substr(i + searchTerm.length);
          lcBodyText = bodyText.toLowerCase();
          i = -1;
        //}
      }
    }
  }

  return newText;
}

function highlightSearchTerms(origText, searchText)
{
  searchArray = searchText.split(" ");
  var bodyText = origText;
  for (var i = 0; i < searchArray.length; i++) {
    if(searchArray[i].length == 0)
    {
      continue;
    }
    bodyText = doHighlight(bodyText, searchArray[i]);
  }
  
  document.write(bodyText);
}

function highlightConfigSearchTerms(origText, searchText)
{
  var highlightStartTag = "<font style='color:#000000; background-color:#A4D7F0;'>";
  var highlightEndTag = "</font>";

  var searchArray = searchText.split(",");
  var bodyText = origText;
  var len = searchArray.length;
  for(var i=0;i<len;i++) {
    if(searchArray[i].length == 0)
    {
      continue;
    }
    bodyText = doHighlight(bodyText, searchArray[i], highlightStartTag, highlightEndTag);
  }
  
  var lineArray = bodyText.split('\n');
  var len = lineArray.length;
  bodyText = "";
  var matchingLinesText = "";
  for(var j=0;j<len;j++)
  {
    bodyText = bodyText + lineArray[j] + "<br>";
    
    if(lineArray[j].indexOf(highlightStartTag) != -1)
    {
      matchingLinesText = matchingLinesText + lineArray[j] + "<br>";
    }
  }
  
  document.write(bodyText);
  return matchingLinesText;
  
}

function showNavig(showPrev,showNext)
{
    if(showPrev == true && showNext == true)
    {
    	var obj = document.getElementById('prevLinkTD');
    	obj.className = "";
    	
    	obj = document.getElementById('nextLinkTD');
    	obj.className = ""; 
    }
    else if(showPrev == true)
    {
    	var obj = document.getElementById('prevLinkTD');
    	obj.className = "";
    	
    	obj = document.getElementById('nextLinkTextTD');
    	obj.className = ""; 
    }
    else if(showNext == true)
    {
    	var obj = document.getElementById('prevLinkTextTD');
    	obj.className = "";
    
    	obj = document.getElementById('nextLinkTD');
    	obj.className = ""; 
    }
    else
    {
    	var obj = document.getElementById('prevLinkTextTD');
    	obj.className = "";
    	
    	obj = document.getElementById('nextLinkTextTD');
    	obj.className = ""; 
    }
}

function validateFileSelection(startup,running)
{
  if(startup.checked == false && running.checked == false)
  {
     alert('Please select the file to be searched');
     return false;
  }
  
  return true;
}

function handleNext(lastResourceId)
{
  var form = document.SearchForm;
  var actionUrl = form.action;
  actionUrl = actionUrl + "?IS_NEXT=true&LAST_RESOURCE_ID=" + lastResourceId;
  form.action = actionUrl;
  handleStateForForm(form);
  form.submit();
}

function handlePrevious(firstResourceId)
{
  var form = document.SearchForm;
  var actionUrl = form.action;
  actionUrl = actionUrl + "?IS_PREV=true&FIRST_RESOURCE_ID=" + firstResourceId;
  form.action = actionUrl;
  handleStateForForm(form);  
  form.submit();
}

function showLines(all)
{
  var matching = document.getElementById("matching_lines");
  var matchingTxt = document.getElementById("matching_linesTxt");  
  var allLines = document.getElementById("all_lines");
  var allLinesTxt = document.getElementById("all_linesTxt");
  
  var matchingTR = document.getElementById("matching_lines_TR");
  var allLinesTR = document.getElementById("all_lines_TR");
  
  // Show all lines clicked
  if(all == 'true')
  {
     matching.className = "";
     matchingTxt.className = "hide";
     allLines.className = "hide";
     allLinesTxt.className = "keyword";
     
     allLinesTR.className = "";
     matchingTR.className = "hide";
  }
  // Show only matching lines clicked
  else
  {
    allLines.className = "";
    allLinesTxt.className = "hide";
    matching.className = "hide";
    matchingTxt.className = "keyword";
    
    matchingTR.className = "";
    allLinesTR.className = "hide";
  }
}

function encodeToHtml(str)
{
   while(str.indexOf('"') != -1)
   {
      str = str.replace('"',"&quot;");
   }

   while(str.indexOf("<") != -1)
   {
      str = str.replace("<","&lt;");
   }

   while(str.indexOf(">") != -1)
   {
      str = str.replace(">","&gt;");
   }

   return str;

}